/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/
#include "common.h"
CSound Sound;
void musicDone()
{
	return;
}
int CSound::Init()
{
    extern void fill_audio(void *udata, Uint8 *stream, int len);
	if(SDL_InitSubSystem(SDL_INIT_AUDIO) < 0){
		fprintf( stderr, "Unable to open audio: %s\n", SDL_GetError( ) );
		return 0;
	}
    if ( Mix_OpenAudio( 11025, MIX_DEFAULT_FORMAT , 1, 512 ) < 0 )
	{
	    fprintf( stderr, "Unable to open audio: %s\n", SDL_GetError( ) );
	    Quit( 1 );
	}

	Mix_AllocateChannels(8);
	return 1;
}
void CSound::Stop()
{
	SDL_QuitSubSystem(SDL_INIT_AUDIO);
}

int CIndivSound::Load(char *file)
{
	char buff[128];
	sprintf(buff,"%s%s",DataDir,file);
	wave = Mix_LoadWAV_RW(SDL_RWFromFile(buff, "rb"), 1);
	if(!wave) {
		printf("Mix_LoadWAV: %s\n", Mix_GetError());
		// handle error
	}
	Mix_VolumeChunk(wave, MIX_MAX_VOLUME) ;

	return 1;
}

int CIndivSound::Play()
{
    chan = Mix_PlayChannel(-1, wave, 0);
	if(chan ==-1) {
		printf("Mix_PlayChannel: %s\n",Mix_GetError());
		// may be critical error, or maybe just no channels were free.
		// you could allocated another channel in that case...
	}

	return 1;
	
}

void CIndivSound::Destroy()
{
	//buffer->Release();
}
int CIndivMusic::Load(char *file)
{
	music = Mix_LoadMUS(file);


	return 1;
}

int CIndivMusic::Play()
{
	Mix_PlayMusic(music, 0);
	Mix_HookMusicFinished(musicDone);
	return 1;
}

void CIndivMusic::Destroy()
{
	//buffer->Release();
}