/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/

#ifndef DEF_COMMON_H
#define DEF_COMMON_H
#define DEBUG
#define TITLE "SDLBlock"
#define MAX_TEXTURES 1024
#define LOGFILE "log.txt"
#define DataDir "data\\"

//------------------------------------------------------------------//
//					 TYPEDEFS && DEFINES
//------------------------------------------------------------------//
#define PI		3.14159265358979323846	// matches value in gcc v2 math.h
#define RANDOM_FLOAT (((float)rand()-(float)rand())/RAND_MAX)
#define DEG_TO_RAD(angle)  ((angle)*PI/180)
#define RAD_TO_DEG(radians) ((radians)*180/PI)
#define SQUARE(number) (number*number)

/*-------------------------------------------------------
					Includes
-------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL.h>
#include <SDL_opengl.h>
#include <SDL_mixer.h>
#include <GL/glu.h>
#include <GL/glaux.h>
#include <malloc.h>
#include <math.h>		
#include <time.h>
#include "texture.h"
#include "Init.h"
#include "CGl.h"
#include "log.h"
#include "CSound.h"
#include "CMenu.h"
#include "SDLBlock.h"
#include "Blocks.h"
#include "Font.h"

#define DEG_TO_RAD(angle)  ((angle)*PI/180)
#define RAD_TO_DEG(radians) ((radians)*180/PI)

/*-------------------------------------------------------
					Globals
-------------------------------------------------------*/
extern unsigned long ticktime;

extern int isActive;
extern int keys[256];
extern int keyc[256];
int DrawGLScene(GLvoid);									// Here's Where We Do All The Drawing
void InitGame();
void RestartGame(int h,int w,int d,int l,int s);
extern int fullscreen;


#endif